/***************************  Hiwi.java  **************************************/

import AlgoTools.IO;

/** Klasse Hiwi 
 *  spezialisiert die Klasse Student durch weiteres Datenfeld gehalt
 *  und durch eigene Konstruktoren
 */

public class Hiwi extends Student {             // Hiwi erbt von Student

  double gehalt;                                // Hiwigehalt

  public Hiwi (String vn, String nn,            // Konstruktor mit Name 
               int t, int m, int j,             // Geburtsdatum 
               String fach, int jsb,            // Fach, Jahr des Studienbeginns
               double gehalt) {                 // Gehalt       
    super(vn, nn, t, m, j, fach, jsb);          // Konstruktor des Vorfahren
    this.gehalt = gehalt;                       // initialisiere Gehalt 
  }

  public Hiwi (Student s,                       // Konstruktor mit Student
        double gehalt) {                        // und Gehalt 
    super(s);                                   // klone Student 
    this.gehalt = gehalt;                       // initialisiere Gehalt
  }

  public static void main (String argv[]) {
 
    Person p;                                             // deklariere Person
    Student s;                                            // deklariere Student
    Hiwi h;                                               // deklariere Hiwi

    p = new Person("Pit","Krueger",24,12,1971);           // kreiere Person
    s = new Student("Willi","Wum",15,9,1972,"BWL",1993);  // kreiere Student  
    h = new Hiwi("Jan","Ott",2,3,1973,"BIO",1994,123.45); // kreiere neuen Hiwi
    h = new Hiwi(s,234.56); s=null;                       // Student wird Hiwi 

    IO.println(p.nachname+"'s Jahrgang: "+p.jahrgang());  // gib Jahrgang aus
    p = h;                                                // p zeigt auf h
    IO.println(p.nachname+"'s Jahrgang: "+p.jahrgang());  // gib Jahrgang aus

    IO.println(h.gehalt);                                 // gib h's Gehalt aus
    if (p instanceof Hiwi) IO.println(((Hiwi)p).gehalt);  // gib p's Gehalt aus 
    h = (Hiwi) p;                                         // h zeigt auf p 
  }
}
