/*****************************  ListeTest.java  *******************************/

import AlgoTools.IO;

/** Testet die Klasse Liste mit Studenten
 */

public class ListeTest {

  public static void main (String argv[]) {

    Liste l = new Liste();                                 // kreiere Liste
    Student s;                                             // deklariere Student

    s = new Student("Willi","Wacker",22,8,1972,"BWL",1995);// kreiere Student  
    l.insert(s);                                           // fuege in Liste ein
    l.advance();                                           // eins weiter in l

    s = new Student("Erika","Muster",28,2,1970,"VWL",1994);// kreiere Student  
    l.insert(s);                                           // fuege in Liste ein
    l.advance();                                           // eins weiter in l

    s = new Student("Hein","Bloed",18,5,1973,"CLK",1996);  // kreiere Student  
    l.insert(s);                                           // fuege in Liste ein
    l.advance();                                           // eins weiter in l

    s = new Student("Susi","Sorglos",10,7,1973,"JUR",1996);// kreiere Student  
    l.insert(s);                                           // fuege in Liste ein

    l.reset();                                             // an den Anfang

    while (!l.endpos()) {                                  // 1.,3.,5.. loeschen
      l.delete(); if (!l.endpos()) l.advance();
    }

    l.reset();                                             // an den Anfang
    
    while (!l.endpos()) {                                  // Liste ausgeben
      IO.println(((Student)l.elem()).vorname+" "+((Student)l.elem()).nachname);
      l.advance();                                         // ein weiter in l
    }

    l.reset();                                             // an den Anfang

    while (!l.empty()) l.delete();                         // Liste loeschen
  }
}
