/***************************  Person.java  ************************************/

import AlgoTools.IO;

/** Klasse Person
 *  bestehend aus Vorname, Nachname, Geburtsdatum 
 *  mit zwei Konstruktoren zum Anlegen einer Person
 *  und zwei Methoden zum Ermitteln des Jahrgangs und des Alters 
 */

public class Person {

  String vorname;                                   // Datenfeld Vorname 
  String nachname;                                  // Datenfeld Nachname 
  Datum  geb_datum;                                 // Datenfeld Geburtsdatum

  public Person(String vn, String nn,               // Konstruktor mit    
                int t, int m, int j) {              // Parametern 
    vorname   = vn;                                 // initialisiere Vorname 
    nachname  = nn;                                 // initialisiere Nachname
    geb_datum = new Datum(t,m,j);                   // initialisiere Geburtsdat.
  }

  public int jahrgang () {                          // Methode
    return geb_datum.jahr;                          // liefert Geburtsjahrgang
  }

  public int alter(){                               // Methode
    return 1998 - geb_datum.jahr;                   // liefert das Lebensalter
  }

  public static void main (String argv[]) {
 
    Person p;                                       // deklariere eine Person

    p = new Person("Willi","Wacker",22,8,1972);     // kreiere Person
    p.geb_datum.jahr++;                             // mache sie 1 Jahr juenger 
    IO.print(p.vorname + " " + p.nachname);         // gib Name aus
    IO.println(" ist " + p.alter() + " Jahre alt.");// gib Alter aus
  }
}
